"""
The Puzzle
4 Chalices are labelled A,B, C, D  
Only one is a real diamond encrusted chalice from medieval times. 
However there is a clue as to which chalice is the real one: 
        If you count the chalices in the order ABCDCBABCDCBA 
        ....and so on 
        The real authentic chalice is the 101st chalice. 
Which one is the real chalice? <br>

Pseudo-Code
#Initialise the conditions
numberChalices = 4; realChalice = 101;
Create a list of 4 letters: chaliceList=  [A,B,C,D]	#’A’ is 65 in ASCII
#Set up the pattern of counting the chalices
For i = 3 to 1 {
	Make a backward list of [C,B,A]
}
For i = 2 to 4 {
	Make a forward list of [B,C,D]
}
While length of chaliceList < 101 {
	Append backward list
	Append forward list
}
101st element of chaliceList will be the real chalice


"""
#-------------------------------------------------------------------------------------------------------

#Initialise the problem. This can be later enhanced by asking the user.
numberChalices = 4
realChalice = 101
chaliceList = []
#Create the full list
for i in range(numberChalices) :
        chaliceList.append(chr(65+i))   # 'A' = 65 in ASCII code

        
#Make a copy of the initial list for later use
originalList = chaliceList[:]

#"CBA" for 4 chalices
bwList = chaliceList[:numberChalices-1]
bwList.reverse()                        # lots of ways to reverse a list ... a[::-1]

#"BCD" for 4 chalices
fwList = chaliceList[1:]

while (len(chaliceList) < realChalice) :
        chaliceList += bwList
        chaliceList += fwList
        
print("Number of Chalices : ", numberChalices, "\n")
print("Initial List of Chalices : ", originalList, "\n")
print("Real Chalice Location : ", realChalice, "\n")
print("Full Chalice Sequence \n")
print(chaliceList , "\n")
print("Real Chalice located at position " + str(realChalice), "is Chalice", chaliceList[realChalice-1])



        
        

       

